function mylpgui(action)
clc
global seg
global Nimf
global T1
global T2
global T3
global Lpoly
global pf
global ppulse
global psp1
global psp2
global psp3
global imf
global r
global plot_offset
global seg_dt
global declick_flag
global fs_seg
global dt_seg

global cf_win_len
cf_win_len=201; % (odd value) length of the crossfade window (in samples) 
global fo_win_len
fo_win_len=501; % (odd value)length of the large fade-out window (in samples)

cf_win_large=hanning(2*fo_win_len+1);
cf_win_in_L=cf_win_large(1:fo_win_len);

global cf_win_out_L
cf_win_out_L=[1;flipud(cf_win_in_L);0];
clear cf_win_large cf_win_in_L

cf_win=hanning(2*cf_win_len+1);
global  cf_win_in
cf_win_in=cf_win(1:cf_win_len);
global  cf_win_out
cf_win_out=flipud(cf_win_in);
clear cf_win

global SE
SE=100;  % number of samples of the backward extension

switch(action)  
case 'loadpulse',
    loadpulse;
case 'Nimf_choice'
    Nimf_flag=findobj(gcbf,'Tag','popupmenu3');
    Nimf=round(get(Nimf_flag,'Value'));    
    Nimf=Nimf+1;
    [imf,r]=pulse_estimate_emd(seg); 
case 'start1',
    set(gcbf,'WindowButtonMotionFcn','mylpgui move1');
    set(gcbf,'WindowButtonUpFcn','mylpgui stop1');
case 'move1',
    currPt=get(gca,'CurrentPoint');
    T1=round(max(50,min(T2-cf_win_len,currPt(1,1))));
    set(psp1,'XData',[T1 T1]); 
    [imf,r]=pulse_estimate_emd(seg); 
case 'stop1',
    set(gcbf,'WindowButtonMotionFcn','');
    set(gcbf,'WindowButtonUpFcn','');    
case 'start2',
    set(gcbf,'WindowButtonMotionFcn','mylpgui move2');
    set(gcbf,'WindowButtonUpFcn','mylpgui stop2');
case 'move2',
    currPt=get(gca,'CurrentPoint');
    T2=round(max(T1+cf_win_len,min(T3-cf_win_len,currPt(1,1))));
    set(psp2,'XData',[T2 T2]);
case 'stop2',
    set(gcbf,'WindowButtonMotionFcn','');
    set(gcbf,'WindowButtonUpFcn','');
case 'start3',
    set(gcbf,'WindowButtonMotionFcn','mylpgui move3');
    set(gcbf,'WindowButtonUpFcn','mylpgui stop3');
case 'move3',
    lseg=length(seg);
    currPt=get(gca,'CurrentPoint');
    T3=round(max(T2+cf_win_len,min(lseg-round(1.5*fo_win_len),currPt(1,1))));
    set(psp3,'XData',[T3 T3]);
case 'stop3',
    set(gcbf,'WindowButtonMotionFcn','');
    set(gcbf,'WindowButtonUpFcn','');
case 'pf_flag',
    pf=~pf;
    pf_o=findobj(gcbf,'Tag','slider7');
    if pf,
        set(pf_o,'Enable','On');
    elseif ~pf
        set(pf_o,'Enable','Off');
    end
case 'polyf'
    pf_o=findobj(gcbf,'Tag','slider7');
    Lpoly=round(get(pf_o,'Value'));    
    Lpolytext=findobj(gcbf,'Tag','text13');
    set(Lpolytext,'String',num2str(Lpoly));    
case 'export_param'
    export_param;
case 'save_proc_signal'
    save_proc_signal;    
case 'declick_flag'
    declick_flag=~declick_flag;  
case 'play_orig'
    play_orig_o=findobj(gcbf,'Tag','pushbutton3');
    play_proc_o=findobj(gcbf,'Tag','pushbutton4');
    set(play_orig_o,'Enable','Off');
    set(play_proc_o,'Enable','Off');
    drawnow
    wavplay(seg,fs_seg,'sync');
    set(play_orig_o,'Enable','On');
    set(play_proc_o,'Enable','On');
case 'play_proc'
    play_proc_o=findobj(gcbf,'Tag','pushbutton4');
    play_orig_o=findobj(gcbf,'Tag','pushbutton3');
    set(play_orig_o,'Enable','Off');
    set(play_proc_o,'Enable','Off');
    drawnow
    wavplay(dt_seg,fs_seg,'sync');
    set(play_orig_o,'Enable','On');
    set(play_proc_o,'Enable','On');
end

lseg=length(seg);
pe=update_pulse_segmentation(r,imf); 
set(ppulse,'YData',pe(1:lseg)+plot_offset);
if declick_flag,
    dt_seg=seg(1:lseg)-pe(1:lseg);  % de-thumped signal
    gap_length=180; gl2=floor(gap_length/2);
    ff1=2*gap_length;   % half the size around T1 used to signal interpolation 
    rg=T1-ff1+1:T1+ff1;
    [dt_seg_aux]=reconstruction(1e-3,round(gap_length/3),ff1-gl2+1:ff1+gl2,dt_seg(rg)); % reconstructs signal to replace the inical click
    dt_seg(rg)=dt_seg_aux;
else
    dt_seg=seg(1:lseg)-pe(1:lseg);  % de-thumped signal
end
set(seg_dt,'YData',dt_seg);

function loadpulse
global seg
global Nimf
global T1
global T2
global T3
global Lpoly
global pf
global ppulse
global pseg
global psp1
global psp2
global psp3
global imf
global r
global file_name
global plot_offset
global seg_dt
global declick_flag
global fs_seg

file_name=uigetfile('*.wav','Select the Wave File');
id_filename_o=findobj(gcbf,'Tag','text14');
set(id_filename_o,'String',['Filename: ',file_name]);

[seg,fs_seg]=wavread(file_name);
lseg=length(seg);
T1=500;
T2=T1+500;
T3=T1+1550;
maxs=max(seg);
mins=min(seg);
plot_offset=(1.5*maxs);

Nimf_flag=findobj(gcbf,'Tag','popupmenu3');
Nimf=round(get(Nimf_flag,'Value'));
Nimf=Nimf+1;
LP=findobj(gcbf,'Tag','slider7');
Lpoly=round(get(LP,'Value'));

pf_flag=findobj(gcbf,'Tag','radiobutton1');
pf=get(pf_flag,'Value');

declick_flag_obj=findobj(gcbf,'Tag','radiobutton2');
declick_flag=get(declick_flag_obj,'Value');


[imf,r]=pulse_estimate_emd(seg); 
pe=update_pulse_segmentation(r,imf); 
hold off
pseg=plot(1:lseg,seg+plot_offset);
axis([1 lseg mins*1.01 2.5*maxs*1.01])
hold on
psp1=plot([T1 T1],[-1 1]+plot_offset,'Color',[1 .7 0],'linewidth',1.3);
psp2=plot([T2 T2],[-1 1]+plot_offset,'-r','linewidth',1.3);
psp3=plot([T3 T3],[-1 1]+plot_offset,'-g','linewidth',1.3);
ppulse=plot(1:lseg,pe(1:lseg)+plot_offset,'-k','linewidth',2);
seg_dt=plot(1:lseg,seg(1:lseg)-pe(1:lseg),'-k','linewidth',2);
set(psp1,'ButtonDownFcn','mylpgui start1','EraseMode','xor');
set(psp2,'ButtonDownFcn','mylpgui start2','EraseMode','xor');
set(psp3,'ButtonDownFcn','mylpgui start3','EraseMode','xor');
set(pf_flag,'Enable','On')
set(Nimf_flag,'Enable','On')

play_proc_o=findobj(gcbf,'Tag','pushbutton4');
play_orig_o=findobj(gcbf,'Tag','pushbutton3');
set(play_orig_o,'Enable','On');
set(play_proc_o,'Enable','On');

export_button=findobj(gcbf,'Tag','pushbutton2');
set(export_button,'Enable','On')

save_proc_o=findobj(gcbf,'Tag','pushbutton5');
set(save_proc_o,'Enable','On');


function save_proc_signal
global fs_seg
global dt_seg
[save_filename] = uiputfile('*.wav', 'Save Processed Signal Parameters as');
wavwrite(dt_seg,fs_seg,save_filename);



function export_param
global Nimf
global T1
global T2
global T3
global Lpoly
global pf
global file_name

if pf, 
    Calib_data={'Filename','Nimf','T1 (in samples)','T2 (in samples)','T3 (in samples)',...
        'Length T1<->T2 (in samples)','Length T2<->T3 (in samples)',...
        'Polynomial Smoothing (PS)','PS order','PS frame T1-T2',...
        'PS frame T2-T3','PS frame T3-END';file_name,Nimf,T1,T2,T3,T2-T1,...
        T3-T2,'Yes',2,Lpoly,2*Lpoly,4*Lpoly}';
else
    Calib_data={'Filename','Nimf','T1 (in samples)','T2 (in samples)','T3 (in samples)',...
        'Length T1<->T2 (in samples)','Length T2<->T3 (in samples)',...
        'Polynomial Smoothing (PS)';file_name,Nimf,T1,T2,T3,T2-T1,T3-T2,'No'}';
end    

[export_filename] = uiputfile('*.txt', 'Save Calibration Parameters as');
dlmcell(export_filename,Calib_data);


function [imf,r]=pulse_estimate_emd(seg)

global SE
global Nimf
global T1

seg=seg(T1:end); 
[seg]=signal_ext_mirror(seg,SE);  % extension of SE samples backward
[imf,r] = emd(seg,Nimf,'pchip',1); r=r(:);

function [imf,r] = emd(x,Nmax,method,tp)
% Empirical Mode Decomposition
%	Input: x, Nmax
% method: envelope interpolation: 'spline' or 'pchip'
% tp: two-pass envelope computation? tp=1 (yes) or tp=0 (no)
%	Output: imf,r

N = length(x);
if(nargin==1)
  Nimf = round(log2(N)) + 5; 
else 
  Nimf = Nmax;
end

% initializes IMF matrix
imf = zeros(N,Nimf);

jj = 0; % Counter of IMFs
while (numbextrema(x) > 4) && (jj < Nimf),
  h1 = x;    % row vector  
 if numbextrema(h1) < 4,
    disp('Forced stop. Insuficient number of extremas during sifting.');
 else  % No sifting done here for simplicity
    [env_sup, env_inf] = envelopes_emd(h1,method,tp);
    h2 = h1 - 0.5 * (env_sup + env_inf);
    h1 = h2;
 end
 jj=jj+1;
 imf(:,jj) = h1;
 x = x - h1;
end
r = x; % residue

function [env_sup,env_inf]=envelopes_emd(x,method,tp)
% x: input signal whose upper and lower envelopes will be computed
% method: name of method to be used for interpolation 'spline' or 'pchip';
% tp: two-pass envelope computation: tp=1 (yes)

N = length(x);
[idx_max, idx_min] = extremas(x);

% post_processing min max
t = 1:N;t=t(:);
xx = x(idx_max);
tt = t(idx_max);

if length(xx)>=2, % at least two maxima in x
    % linear extrapolation of max extremas
    slopei = (xx(2) - xx(1)) / (tt(2) - tt(1)); % initial slope
    xi = slopei*t(1) + xx(1)-slopei*tt(1);
    xi = max(x(1),xi);
    slopef = (xx(end) - xx(end-1)) / (tt(end) - tt(end-1)); % final slope
    xf = slopef*(t(end)-tt(end-1))+xx(end-1);
    xf = max(x(end),xf);
    xx = [xi; xx; xf]; 
    tt = [t(1); tt; t(end)]; 
    env_sup = interp1(tt,xx,t, method);
elseif length(xx)==1,
    xx = [x(1); xx; x(end)]; 
    tt = [t(1); tt; t(end)];
    env_sup = interp1(tt,xx,t, method);
else
    env_sup=[];
    disp('no sup envelope')
end

% ending points for inferior envelope
xx = x(idx_min);
tt = t(idx_min);

if length(xx)>=2, % at least two minima in x
    
    % linear extrapolation of min extremas
    slopei = (xx(2) - xx(1)) / (tt(2) - tt(1)); % initial slope
    xi = slopei*t(1) + xx(1)-slopei*tt(1);
    xi = min(x(1),xi);
    slopef = (xx(end) - xx(end-1)) / (tt(end) - tt(end-1)); % final slope
    xf = slopef*(t(end)-tt(end-1))+xx(end-1);
    xf = min(x(end),xf);
    xx = [xi; xx; xf]; 
    tt = [t(1); tt; t(end)]; 
    env_inf = interp1(tt,xx,t, method);
elseif length(xx)==1,
    xx = [x(1); xx; x(end)]; 
    tt = [t(1); tt; t(end)];
    env_inf = interp1(tt,xx,t, method);
else
    env_inf=[];
    disp('no inf envelope')
end

if (tp)&&(~isempty(env_sup)),
    ux=x;
    aux1=((ux-env_sup)>=0).*(ux-env_sup);
    if ~isempty(aux1),
        [env_sup1] = sup_envelop(aux1);
        env_sup=env_sup+env_sup1;
    end
end

if (tp)&&(~isempty(env_inf)),
    dx=-x;
    aux1=((dx+env_inf)>=0).*(dx+env_inf);  % 
    if ~isempty(aux1),
        [env_inf1] = sup_envelop(aux1);
        env_inf=(env_inf-env_inf1);
    end
end

function numbextr = numbextrema(x)
% number of local extrema;
%	Input: x, a 1D vector.
%	Output: numbextr, integer.
[idx_max, idx_min] = extremas(x);
numbextr = length(idx_max) + length(idx_min);

function [idx_max, idx_min] = extremas(x)
% Indices of maxima and minima extremas of data.
%	Input: x; 1D vector
%	Output: idx_max, idx_min; Indeces of local maxima and minima of x, respectively.

idx_max = find( (x(3:end) < x(2:end-1)) & (x(1:end-2) < (x(2:end-1) ) ) ) +1; 
idx_min = find( (x(3:end) > x(2:end-1)) & (x(1:end-2) > (x(2:end-1) ) ) ) +1; 

function [xe]=signal_ext_mirror(x,N)
% x: original signal
% xe: extended signal (in the beginning)
% N: number of samples to extend backward
% p: model order

% Obs: length(x)>=N

x=x(:); % makes x  a column vector

xini=x(1:N);
xe=[-flipud(xini)+2*x(1); x];

function [env_sup] = sup_envelop(x)
% Upper envelope of x, based on local extrema;
%	Input: x, a 1D vector.
%	Output: env_sup

method = 'pchip';
N = length(x);
x=abs(x);x=x(:);
idx_max=find((x(3:end)<x(2:end-1)) & (x(1:end-2)<(x(2:end-1))))+1; 
% post_processing min max
t = 1:N;t=t(:);

% ending points for superior envelope
xx = x(idx_max);
tt = t(idx_max);

if length(xx)>=2, % at least two maxima in x
    % linear extrapolation of max extremas
    slopei = (xx(2) - xx(1)) / (tt(2) - tt(1)); % initial slope
    xi = slopei*t(1) + xx(1)-slopei*tt(1);
    xi = max(x(1),xi);
    slopef = (xx(end) - xx(end-1)) / (tt(end) - tt(end-1)); % final slope
    xf = slopef*(t(end)-tt(end-1))+xx(end-1);
    xf = max(x(end),xf);
    xx = [xi; xx; xf]; 
    tt = [t(1); tt; t(end)]; 
    env_sup = interp1(tt,xx,t,method);
elseif length(xx)==1,
    xx = [x(1); xx; x(end)]; 
    tt = [t(1); tt; t(end)];
    env_sup = interp1(tt,xx,t,method);
else
    env_sup=[];
    disp('no sup envelope')
end


function [p_est]=update_pulse_segmentation(r,imf) 

global SE
global Nimf
global T1
global T2
global T3
global Lpoly
global pf

global cf_win_len
global fo_win_len
global cf_win_out_L
global cf_win_in
global cf_win_out

%Remember: EMD analysis is performed on the backward-extended signal

p1=r+imf(:,Nimf)+imf(:,Nimf-1);
p2=r+imf(:,Nimf);

if pf, % if polynomial fitting mode is on, enters here
    rg=(1:((T2-T1)+SE+Lpoly));
    p1(rg)=piecefit_mod(p1(rg),Lpoly,2); % polynomial smoothing of the begining of the pulse estimate   
    rg=(max(T2-T1+SE-2*Lpoly,1):min(T3-T1+SE+2*Lpoly,length(p2)));
    p2(rg)=piecefit_mod(p2(rg),2*Lpoly,2); % polynomial smoothing of the intermediate part of the pulse estimate (uses twice the frame size)   
   rg=max(T3-T1+SE-4*Lpoly,1):length(r);
   r(rg)=piecefit_mod(r(rg),4*Lpoly,2);  % polynomial smoothing of the final part of the pulse estimate (uses four times the frame size)    
end 

r=[zeros(T1-1,1);r((SE+1):end)]; % baseline estimation
p1=[zeros(T1-1,1);p1(SE+1:end)];
p2=[zeros(T1-1,1);p2(SE+1:end)];

aux1=floor(cf_win_len/2);
w1=[zeros(T1-1,1); ones(T2-aux1-T1-1,1); cf_win_out];
len_w1=length(w1);
w1=[w1; zeros(length(p1)-len_w1,1)];
w2=[zeros(len_w1-cf_win_len,1); cf_win_in; ones(T3-aux1-T2-1,1); cf_win_out];
len_w2=length(w2);
w2=[w2; zeros(length(p2)-len_w2,1)];
w3=[zeros(len_w2-cf_win_len,1); cf_win_in; ones(length(r)-cf_win_len-fo_win_len-T3,1); cf_win_out_L];
p_est=p1.*w1+p2.*w2+r.*w3;

function [pa]=piecefit_mod(x,seg,mo)

% This function implements the second stage of the pulse estimation method: 
%  piecewise polynomial fiiting.
%
% Input arguments
%
% 'x': the imput signal, i.e., the pulse estimate output from the first stage (TPSW)
% 'seg': is the window length in samples
% 'mo': is the polynomial order
% 
% Output:
% 
% pa: smoothed pulse estimate

% Paulo Esquef 28.09.2002
% Latest updates: 26.07.2012
x=x(:);
% gg=zeros(size(x)); % buffer to store the OLA compensation
% The overlap factor is fixed at 75%. Hence we need to check if winl is divisible by 4.
seg=round(seg/4)*4;  % makes it divisible by 4
w=[0; hanning(seg-1);0]; w=w(:)./2; % Hanning is used in this case. The 1/2 factor is due to the
                           % 75% overlap.
sp=.75*seg+1;  % The overlap factor is fixed at 75% 
seg=seg+1;   % adds 1 to the length of the window 
ls=length(x);
basis=(1:seg)';  % this vector contains the values for which the polynomial is evaluated;
nblocks=fix((ls-sp)/(seg-sp));  % calculate the number of blocks used in the procedure;
                                % better treatment of the boundaries would be nice to be included                                
lsc=(nblocks)*(seg-sp)+seg; % compensated signal length so as to fill a integer number of blocks 
nsamples_ext=lsc-ls;  % number of samples to appended to x (mirrored)

x=[x;x(end:-1:end-(nsamples_ext-1))]; % extended x
gg=zeros(size(x)); % buffer to store the OLA compensation                          
pa=zeros(lsc,1);    % creates beforehand the output signal; this alleviates the burden of boundary treatment
for kk=0:(nblocks),
   rgs=kk*(seg-sp)+(1:seg);
   bump=x(rgs); % segment to be fitted
   p=polyfit(basis,bump,mo);    % computes the values of the polynomial coefficients
   smbump=polyval(p,basis);     % evaluates the polynomial within the predefined interval 
   smbump=smbump(:);
   pa(rgs)=pa(rgs)+(smbump.*w);  % OLA of the smoothed segments
   gg(rgs)=gg(rgs)+w;  % OLA of the windows (for boundary compensation purposes)
end
pa=pa(1:ls); % discards signal extension
gg=gg(1:ls); % discards signal extension (OLA)
pa=pa./max(gg,1e-4);




function dlmcell(file,cell_array,varargin)
% <><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><> %
% <><><><><>     dlmcell - Write Cell Array to Text File      <><><><><> %
% <><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><> %
%                                                 Version:    01.06.2010 %
%                                                     (c) Roland Pfister %
%                                             roland_pfister@t-online.de %
% 1. Synopsis                                                            %
%                                                                        %
% A single cell array is written to an output file. Cells may consist of %
% any combination of (a) numbers, (b) letters, or (c) words. The inputs  %
% are as follows:                                                        %
%                                                                        %
%       - file       The output filename (string).                       %
%       - cell_array The cell array to be written.                       %
%       - delimiter  Delimiter symbol, e.g. ',' (optional;               %
%                    default: tab ('\t'}).                               %
%       - append     '-a' for appending the content to the               %
%                    output file (optional).                             %
%                                                                        %
% 2. Example                                                             %
%                                                                        %
%         mycell = {'Numbers', 'Letters', 'Words','More Words'; ...      %
%                    1, 'A', 'Apple', {'Apricot'}; ...                   %
%                    2, 'B', 'Banana', {'Blueberry'}; ...                %
%                    3, 'C', 'Cherry', {'Cranberry'}; };                 %
%         dlmcell('mytext.txt',mycell);                                  %
%                                                                        %
% <><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><> %

% Check input arguments
if nargin < 2,
    disp('Error - Give at least two input arguments!'); 
    return;
elseif nargin > 4
    disp('Error - Do not give more than 4 input arguments!'); 
    return;
end
if ~ischar(file),
    disp(['Error - File input has to be a string (e.g. ' ...
        char(39) 'output.txt' char(39) '!']); 
    return;
end
if ~iscell(cell_array)
    disp('Error - Input cell_array not of the type "cell"!'); 
    return;
end
delimiter = ': ';
append = 'w';
if nargin > 2
    for i = 1:size(varargin,2)
        if strcmp('-a',varargin{1,i}) == 1
            append = 'a';
        else
            delimiter = varargin{1,i};
        end
    end
end

% Open output file and prepare output array.
output_file = fopen(file,append);
output = cell(size(cell_array,1),size(cell_array,2));

% Evaluate and write input array.
for i = 1:size(cell_array,1)
for j = 1:size(cell_array,2)
    if numel(cell_array{i,j}) == 0
        output{i,j} = '';
    % Check whether the content of cell i,j is
    % numeric and convert numbers to strings.
    elseif isnumeric(cell_array{i,j}) || islogical(cell_array{i,j})
        output{i,j} = num2str(cell_array{i,j}(1,1));
    
    % Check whether the content of cell i,j is another cell (e.g. a
    % string of length > 1 that was stored as cell. If cell sizes 
    % equal [1,1], convert numbers and char-cells to strings.
    %
    % Note that any other cells-within-the-cell will produce errors
    % or wrong results.
    elseif iscell(cell_array{i,j})
        if size(cell_array{i,j},1) == 1 && size(cell_array{i,j},1) == 1
            if isnumeric(cell_array{i,j}{1,1})
                output{i,j} = num2str(cell_array{i,j}{1,1}(1,1));
            elseif ischar(cell_array{i,j}{1,1})
                 output{i,j} = cell_array{i,j}{1,1};
            end
        end
        
     % If the cell already contains a string, nothing has to be done.
    elseif ischar(cell_array{i,j})
         output{i,j} = cell_array{i,j};
    end
     
     % Cell i,j is written to the output file. A delimiter is appended
     % for all but the last element of each row.
     fprintf(output_file,'%s',output{i,j});
     if j ~= size(cell_array,2)
         fprintf(output_file,'%s',delimiter);
     end
end
% At the end of a row, a newline is written to the output file.
fprintf(output_file,'\r\n');
end

%% Close output file.    
fclose(output_file);



function [x,a]=reconstruction(tol,p,falhas,x)
% This function implements the AR-based signal reconstruction
% tol: is an error tolerance used for terminating the iterations
% p: AR model order
% F: maximum length (in samples) gap to be filled
% falhas: indices of samples in x that have considered as corrupted with
% clicks (obtained from detection function)
% x: input signal marred with clicks


if ~isempty(falhas),   % checks whether there are gaps to conceal 

    N=length(x);
    pmais1=p+1; 
    Nmenosp=N-p;
    maxNpF_mf=Nmenosp;   

    anta=zeros(p,1);   % previous coefficients of the AR model
    n=0;			   % iteration

    a=arburg(x(1:maxNpF_mf),p);  % current AR model estimation
    a(1)=[];
    a=a(:);
    a=-a;

    % Performs signal reconstruction while the "differences" between the current and previous AR models are above tol  
    while (norm(a-anta)/norm(a))>tol
       n=n+1;
       A=sparse(1:Nmenosp,pmais1:N,ones(1,Nmenosp),Nmenosp,N);
       for ii=1:p
          A=A+sparse(1:Nmenosp,(pmais1-ii):(N-ii),-a(ii)*ones(1,Nmenosp),Nmenosp,N);
       end
       falhasaux=1:maxNpF_mf;
       falhasaux(falhas)=[];   
       Ad=A(1:maxNpF_mf-p,falhas);
       Ac=A(1:maxNpF_mf-p,falhasaux);
       clear A;  			   
       xc=x(falhasaux);
       clear falhasaux;
       Adt=Ad';  
       x(falhas)=-(Adt*Ad)\(Adt*(Ac*xc));    % LS AR interpolation
       clear Ad; 
       clear Ac; 
       anta=a;		% current AR model attributed to previous AR model vetor
       a=arburg(x(1:maxNpF_mf),p);   % estimates new (current)AR model from x with already suppressed clicks 
       a(1)=[];
       a=a(:);a=-a;
    end
end 

